local FC = ...

local m = FCconfig["main"]["balance mode"]


local function QuestRewardResources(resources)
	return {
		DataType = "QUEST_REWARD_RESOURCES",
		ResourceCollection = resources
	}
end

local function QuestFunctionDelivery(resources)
	return {
		DataType = "QUEST_FUNCTION_DELIVER_RESOURCES",
		ResourceListToDeliver = resources,
		Estate = "CLERGY",
		DaysCount = 10000000
	}
end

local function QuestFunctionBuild(BuildingList)
	return {
		DataType = "QUEST_FUNCTION_BUILD",
		BuildingListToBuild = BuildingList
	}
end

local function QuestRewardInfluence(influence)
	return {
		DataType = "QUEST_REWARD_INFLUENCE",
		EstateInfluence = influence
	}
end

FC:register({
	DataType = "QUEST",
	Id = "INFINITE_RESOURCES_QUEST",
	Name = "INFINITE_RESOURCES_QUEST_NAME",
	Description = "INFINITE_RESOURCES_QUEST_DESC",
	QuestFunction = QuestFunctionDelivery({{Resource = "TOOL", Quantity = 1}}),	
	QuestRewardList = {
		QuestRewardResources({{Resource = "TOOL", Quantity = 1}}),
	},
	QuestListToUnlockAfter = {{QuestResource = "INFINITE_RESOURCES_QUEST", Delay = 1}}, 
	OnSuccessCallback = {

		DataType = "EVENT_CALLBACK_TRIGGER_EVENT", 
		Event = "INFINITE_RESOURCES_EVENT", 
		Delay = 1

	}
})

FC:register({
	DataType = "QUEST",
	Id = "INFLUENCE_QUEST",
	Name = "INFLUENCE_QUEST_NAME",
	Description = "INFLUENCE_QUEST_DESC",
	QuestFunction = QuestFunctionBuild({"BUILDING_VILLAGE_CENTER"}),
	IsSilent = true,
	QuestRewardList = {
				QuestRewardInfluence({Estate = "CLERGY", Quantity = 4}),
				QuestRewardInfluence({Estate = "KINGDOM", Quantity = 9}),
				QuestRewardInfluence({Estate = "LABOUR", Quantity = 13})
			},
	QuestListToUnlockAfter = {{QuestResource = "INFINITE_RESOURCES_QUEST", Delay = 1}}, 
})

FC:register({
	DataType = "EVENT",
	Id = "WELCOME_EVENT",
	Title = "WELCOME_EVENT_TITLE",
	Description = "WELCOME_EVENT_DESC",
	PanelVisual = "ILLUSTRATION_ESTATE_KING",
	Delay = 0,
	ConditionList = {
		{
		DataType = "EVENT_CONDITION_BUILDING_BUILT",
		AssetBuilding = "BUILDING_VILLAGE_CENTER"
		}
	},
	ActionList = {{	
		DataType = "EVENT_ACTION_GIVE_REWARD",
		QuestRewardList = {},
		OnClickCallback = { 
			DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
			Event = "WELCOME2_EVENT",
			Delay = 1
		},
		ShortName = "WELCOME_ACCEPT"
		}}
})

FC:register({
	DataType = "EVENT",
	Id = "WELCOME2_EVENT",
	Title = "WELCOME2_EVENT_TITLE",
	Description = "WELCOME2_EVENT_DESC",
	PanelVisual = "ILLUSTRATION_ESTATE_KING",
	Delay = 0,
	ConditionList = {
		{
		DataType = "EVENT_CONDITION_BUILDING_BUILT",
		AssetBuilding = "BUILDING_VILLAGE_CENTER"
		}
	},
	ActionList = {{	
		DataType = "EVENT_ACTION_GIVE_REWARD",
		QuestRewardList = {},
		OnClickCallback = { 
			DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
			Event = "WELCOME3_EVENT",
			Delay = 1
		},
		ShortName = "WELCOME2_ACCEPT"
		}}
})

FC:register({
	DataType = "EVENT",
	Id = "WELCOME3_EVENT",
	Title = "WELCOME3_EVENT_TITLE",
	Description = "WELCOME3_EVENT_DESC",
	PanelVisual = "ILLUSTRATION_ESTATE_KING",
	Delay = 0,
	ConditionList = {
		{
		DataType = "EVENT_CONDITION_BUILDING_BUILT",
		AssetBuilding = "BUILDING_VILLAGE_CENTER"
		}
	},
	ActionList = {{	
		DataType = "EVENT_ACTION_GIVE_REWARD",
		QuestRewardList = {},
		OnClickCallback = { 
			DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
			Event = "WELCOME4_EVENT",
			Delay = 1
		},
		ShortName = "WELCOME3_ACCEPT"
		}}
})

FC:register({
	DataType = "EVENT",
	Id = "WELCOME4_EVENT",
	Title = "WELCOME4_EVENT_TITLE",
	Description = "WELCOME4_EVENT_DESC",
	PanelVisual = "ILLUSTRATION_ESTATE_KING",
	Delay = 0,
	ConditionList = {
		{
		DataType = "EVENT_CONDITION_BUILDING_BUILT",
		AssetBuilding = "BUILDING_VILLAGE_CENTER"
		}
	},
	ActionList = {{	
		DataType = "EVENT_ACTION_GIVE_REWARD",
		QuestRewardList = {},
		OnClickCallback = { 
			DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
			Event = "WELCOME5_EVENT",
			Delay = 1
		},
		ShortName = "WELCOME4_ACCEPT"
		}}
})

FC:register({
	DataType = "EVENT",
	Id = "WELCOME5_EVENT",
	Title = "WELCOME5_EVENT_TITLE",
	Description = "WELCOME5_EVENT_DESC",
	PanelVisual = "ILLUSTRATION_ESTATE_KING",
	Delay = 0,
	ConditionList = {
		{
		DataType = "EVENT_CONDITION_BUILDING_BUILT",
		AssetBuilding = "BUILDING_VILLAGE_CENTER"
		}
	},
	ActionList = {{	
		DataType = "EVENT_ACTION_GIVE_REWARD",
		QuestRewardList = {},
		OnClickCallback = { 
			DataType = "EVENT_CALLBACK_TRIGGER_EVENT",
			Event = "WELCOME6_EVENT",
			Delay = 1
		},
		ShortName = "WELCOME5_ACCEPT"
		}}
})

FC:register({
	DataType = "EVENT",
	Id = "WELCOME6_EVENT",
	Title = "WELCOME6_EVENT_TITLE",
	Description = "WELCOME6_EVENT_DESC",
	PanelVisual = "ILLUSTRATION_ESTATE_KING",
	Delay = 0,
	ConditionList = {
		{
		DataType = "EVENT_CONDITION_BUILDING_BUILT",
		AssetBuilding = "BUILDING_VILLAGE_CENTER"
		}
	},
	ActionList = {{	
		DataType = "EVENT_ACTION_GIVE_REWARD",
		QuestRewardList = {},
		ShortName = "WELCOME6_ACCEPT"
		}}
})

function CC (a1)
	if m == "creative" then return a1 else return
		{
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {},
			ShortName = "LOCKED_ACCEPT"
		}
	end
	
end

FC:register({
	DataType = "EVENT",
	Id = "INFINITE_RESOURCES_EVENT",
	Title = "INFINITE_RESOURCES_EVENT_TITLE",
	Description = "INFINITE_RESOURCES_EVENT_DESC",
	PanelVisual = "ILLUSTRATION_ESTATE_CHURCH",
	Delay = 0,
	ConditionList = {
		{
		DataType = "EVENT_CONDITION_BUILDING_BUILT",
		AssetBuilding = "BUILDING_VILLAGE_CENTER"
		}
	},
	ActionList = {
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "BERRIES", Quantity = 1000}
			})},
			ShortName = "BERRIES_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "BREAD", Quantity = 1000}
			})},
			ShortName = "BREAD_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "CLOTHES", Quantity = 1000}
			})},
			ShortName = "CLOTHES_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "DEER", Quantity = 1000}
			})},
			ShortName = "DEER_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "FISH", Quantity = 1000}
			})},
			ShortName = "FISH_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "HERBS", Quantity = 1000}
			})},
			ShortName = "HERBS_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "HONEY", Quantity = 1000}
			})},
			ShortName = "HONEY_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "PLANK", Quantity = 1000}
			})},
			ShortName = "PLANK_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "POLISHED_STONE", Quantity = 1000}
			})},
			ShortName = "POLISHED_STONE_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "STONE", Quantity = 1000}
			})},
			ShortName = "STONE_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "TOOL", Quantity = 1000}
			})},
			ShortName = "TOOL_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "WINE", Quantity = 1000}
			})},
			ShortName = "WINE_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "WOOD", Quantity = 1000}
			})},
			ShortName = "WOOD_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "GLASS", Quantity = 1000}
			})},
			ShortName = "GLASS_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "WOOLEN_CLOTH", Quantity = 1000}
			})},
			ShortName = "WOOLEN_CLOTH_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "GOLD", Quantity = 1000000}
			})},
			ShortName = "GOLD_ACCEPT"
		}),
		CC ({
			DataType = "EVENT_ACTION_GIVE_REWARD",
			QuestRewardList = {QuestRewardResources({
				{Resource = "BERRIES", Quantity = 1000},
				{Resource = "BREAD", Quantity = 1000},
				{Resource = "CLOTHES", Quantity = 1000},
				{Resource = "DEER", Quantity = 1000},
				{Resource = "FISH", Quantity = 1000},
				{Resource = "HERBS", Quantity = 1000},
				{Resource = "HONEY", Quantity = 1000},
				{Resource = "PLANK", Quantity = 1000},
				{Resource = "POLISHED_STONE", Quantity = 1000},
				{Resource = "STONE", Quantity = 1000},
				{Resource = "TOOL", Quantity = 1000},
				{Resource = "WINE", Quantity = 1000},
				{Resource = "WOOD", Quantity = 1000},
				{Resource = "GLASS", Quantity = 1000},
				{Resource = "WOOLEN_CLOTH", Quantity = 1000},
				{Resource = "GOLD", Quantity = 1000000}
			})},
			ShortName = "EVERYTHING_ACCEPT"
		}),
	}
})